// IDS Web Help
//
// This script is based on: Tipue, an open source JavaScript search engine
// The scripts and pages were modified for IDS to enable:
//  - working in a frame environment
//  - working in Microsoft IE 6+ and Firefox
//  - working regardless IE security settings
// It works with any browser that supports JavaScript 1.3 and at least partially supports the W3C DOM Level 1.
//
// More information at: http://www.tipue.com
//
// KdG 2005, axis informatie-ontwerpers. www.axis.nl/informatie-ontwerpers/
//2014 adjusement for cookie blocked browsers


// ---------- script properties ----------

var results_location = "wh_fts.htm";
var max_results = 50; //maximum nr of results
var include_url = 0;  //Include and show the filename-url in the results
var include_desc = 0; //Include and show the description in the results
var bold_query = 0; //Highlight the search terms in the descriptions

// ---------- end of script properties ----------

//Response strings (overwritten by servlet variables) 
var lf0 = "No matches found";
var lf1 = " match found";
var lf2 = " matches found";
var lf3 = "Search in the complete index";

var tm = 0; //Search type (Litteral, or)
var co = 0; //Number of results found
var wt; //Search words array
var tr; //Array with search results
var ir; //Array with search indices

// ---------- wh_form ----------
function doSearch(tip_Form) {
	if (tip_Form.d.value.length > 0) {
		document.cookie = 'tid=' + escape(tip_Form.d.value) + '; path=/';
		do_search();
		tip_out();
		//Display the requested content
		showSearchResult();
	}
}

function getStringFromCookie() {
	var cookies = document.cookie;
	var tp = cookies.indexOf('tid=');

	if (tp != -1) {
		var st = tp + 4;
		var en = cookies.indexOf(';', st);
		if (en == -1) {
			en = cookies.length;
		}
		var dit = cookies.substring(st, en);
		dit = unescape(dit);
	}
	return dit;
}

function do_search() {
	dit = getStringFromCookie(); //dit = search text
	var nb = max_results;
	var nc = 0;
	var nd = 0;
	tr = new Array();
	co = 0;
	if (!dit) dit = escape(tip_Form.d.value) //If cookie with value was not set properly, take string from text input field
	if (dit.charAt(0) == '"' && dit.charAt(dit.length - 1) == '"') {
		tm = 1; //Literal search (search text between quotes)
	}
	var rn = dit.search(/ or /i);
	if (rn >= 0) {
		tm = 2; //Search words eparated by OR
	}
	rn = dit.search(/-/i);
	if (rn >= 0 && tm != 1) {
		rn = dit.search(/ /i);
		if (rn != 0) {
			dit = dit.replace(/-/gi, ' -');
		}
	}
	rn = dit.search(/ not /i);
	if (rn >= 0 && tm != 1) {
		dit = dit.replace(/ not /gi, ' -');
	}
	rn = dit.search(/\+/i);
	if (rn >= 0) {
		rn = dit.search(/ /i);
		if (rn != 0) {
			dit = dit.replace(/\+/gi, ' +');
		}
	}

	if (tm == 0 && dit!="") {//Word search (space or + or AND separated)
		var woin = new Array();
		dit = dit.replace(/ and /gi, ' ');
		dit = dit.replace(/%20/gi, ' '); //escaped space (in Chrome)
		wt = dit.split(' ');
		for (var a = 0; a < wt.length; a++) {
			woin[a] = 0;
			if (wt[a].charAt(0) == '-') {
				woin[a] = 1;
			}
		}
		for (var a = 0; a < wt.length; a++) {
			wt[a] = wt[a].replace(/^\-|^\+/gi, '');
		}
		a = 0;
		for (var c = 0; c < s.length; c++) {
			var es = s[c].split('^');
			var rk = 100;
			if (es[5] == null) {
				es[5] = '0';
			}
			if (parseInt(es[5]) > 10) {
				es[5] = '10';
			}
			var pa = 0;
			var nh = 0;
			for (var i = 0; i < woin.length; i++) {
				if (woin[i] == 0) {
					nh++;
					var nt = 0;
					var pat = new RegExp(wt[i], 'i');
					rn = es[0].search(pat);
					if (rn >= 0) {
						rk = rk - 10;//found in title = rank 10
						rk = rk - parseInt(es[5]);					
						nt = 1;
					}
					rn = es[2].search(pat);
					if (rn >= 0) {
						rk = rk - 8;//found in description = rank 8
						rk = rk - parseInt(es[5]);					
						nt = 1;
					}
					rn = es[3].search(pat);
					if (rn >= 0) {
						rk = rk - 5;//found in content = rank 5
						rk = rk - parseInt(es[5]);					
						nt = 1;
					}
					if (nt == 1) {
						pa++;
					}
				}
				if (woin[i] == 1) {
					var pat = new RegExp(wt[i], 'i');
					rn = es[0].search(pat);
					if (rn >= 0) {
						pa = 0;
					}
					rn = es[2].search(pat);
					if (rn >= 0) {
						pa = 0;
					}
					rn = es[3].search(pat);
					if (rn >= 0) {
						pa = 0;
					}
				}
			}
			if (pa == nh) {
				tr[a] = rk + '^' + s[c];
				a++;
			}
		}
		tr.sort();
		co = a;
	}

	if (tm == 1) {//Literal search (search text between quotes)
		dit = dit.replace(/"/gi, '');
		var a = 0;
		var pat = new RegExp(dit, 'i');
		for (var c = 0; c < s.length; c++) {
			var es = s[c].split('^');
			var rk = 100;
			if (es[5] == null) {
				es[5] = '0';
			}
			if (parseInt(es[5]) > 10) {
				es[5] = '10';
			}
			rn = es[0].search(pat);
			if (rn >= 0) {
				rk = rk - 10;
				rk = rk - parseInt(es[5]);
			}
			rn = es[2].search(pat);
			if (rn >= 0) {
				rk = rk - 8;
				rk = rk - parseInt(es[5]);
			}
			rn = es[3].search(pat);
			if (rn >= 0) {
				rk = rk - 5;
				rk = rk - parseInt(es[5]);
			}
			if (rk < 100) {
				tr[a] = rk + '^' + s[c];
				a++;		
			}
		}
		tr.sort();
		co = a;
	}

	if (tm == 2) {//Search words eparated by OR
		dit = dit.replace(/ or /gi, ' ');
		wt = dit.split(' ');
		var rt = new Array();
		var a = 0;
		for (var i = 0; i < wt.length; i++) {
			var pat = new RegExp(wt[i], 'i');
			for (var c = 0; c < s.length; c++) {
				var es = s[c].split('^');
				var rk = 100;
				if (es[5] == null) {
					es[5] = '0';
				}
				if (parseInt(es[5]) > 10) {
					es[5] = '10';
				}
				var pa = 0;
				var rn = es[0].search(pat);
				if (rn >= 0) {
					rk = rk - 10;
					rk = rk - parseInt(es[5]);		
					if (rn >= 0) {
						for (var e = 0; e < rt.length; e++) {
							if (s[c] == rt[e]) {
								pa = 1;
							}
						}
					}
				}
				rn = es[2].search(pat);
				if (rn >= 0) {
					rk = rk - 8;
					rk = rk - parseInt(es[5]);		
					if (rn >= 0) {
						for (var e = 0; e < rt.length; e++) {
							if (s[c] == rt[e]) {
								pa = 1;
							}
						}
					}
				}
				var rn = es[3].search(pat);
				if (rn >= 0) {
					rk = rk - 5;
					rk = rk - parseInt(es[5]);		
					if (rn >= 0) {
						for (var e = 0; e < rt.length; e++) {
							if (s[c] == rt[e]) {
								pa = 1;
							}
						}
					}
				}
				if (rk < 100 && pa == 0) {
					rt[a] = s[c];
					tr[a] = rk + '^' + s[c];
					a++;
					co++;
				}
			}
		}
		tr.sort();
	}
}


// ---------- External references ----------
function tip_query(od) {//fill form text from cookie value
	if (!od) od = getStringFromCookie();
	if (od != 'undefined' && od != null) document.tip_Form.d.value = od;
}

function tip_out() {
	var result = "";
	if (co == 0) {//no results found
 		result += '<p>' + lf0 + '</p><hr/>';
		if (getmobileindex) {
			result += '<br/><p onclick="javascript: searchFullIndex()" class="resultcount" style="cursor:pointer">'+lf3+'</p>';
		}
		var hlp = document.getElementById("resultcontainer");
		if (hlp) hlp.innerHTML = result;
		return;
	}
	if (co == 1) {
		result += '<p class="resultcount">' + co + lf1 + "</p><hr/>";
	}
	if (co > 1) {
		result += '<p class="resultcount">' + co + lf2 + "</p><hr/>";
	}

	if (max_results > co) {
		nd = co;
	} else {
		nd = max_results;
	}
	result += '<ul id="searchresults">';
	var os
	for (var a = 0; a < nd; a++) {
		result += '<li>';
		os = tr[a].split('^');
		if (os[5] == null) {
			os[5] = '0';
		}
		if (bold_query == 1 && tm == 0) {
			for (var i = 0; i < wt.length; i++) {
				var lw = wt[i].length;
				var tw = new RegExp(wt[i], 'i');
				rn = os[3].search(tw);
				if (rn >= 0) {
					var o1 = os[3].slice(0, rn);
					var o2 = os[3].slice(rn, rn + lw);
					var o3 = os[3].slice(rn + lw);
					os[3] = o1 + '<b>' + o2 + '</b>' + o3;
				}
			}
		}
		if (bold_query == 1 && tm == 1) {
			var lw = dit.length;
			var tw = new RegExp(dit, 'i');
			rn = os[3].search(tw);
			if (rn >= 0) {
				var o1 = os[3].slice(0, rn);
				var o2 = os[3].slice(rn, rn + lw);
				var o3 = os[3].slice(rn + lw);
				os[3] = o1 + '<b>' + o2 + '</b>' + o3;
			}
		}
		if (os[5] == '0') {
			result += '<a href="'+ os[2]+ '" title="'+os[1]+'" onclick="javascript:showContent()">'+ os[1]+ '</a>';
		}
		if (os[5] == '1') {
			result += '<a href="'+ os[2]+ '" target="_blank" title="'+os[1]+'" onclick="javascript:showContent()">'+ os[1]+ '</a>';
		}
		if (os[5] != '0' && os[5] != '1') {
			result += '<a href="'+ os[2]+ '" target="'+ os[5]+ '" title="'+os[1]+'" onclick="javascript:showContent()">'+ os[1]+ '</a>';
		}
		if (os[3].length > 1 && include_desc==1) {
			result += '<br><span class="desc">'+ os[3]+ '</span>';
		}
		if (include_url == 1) {
			if (os[5] == '0') {
				result += '<br><a href="'+ os[2]+ '" title="'+os[1]+'" class="url" onclick="javascript:showContent()">'+ os[2]+ '</a>';
			}			
			if (os[5] == '1') {
				result += '<br><a href="'+ os[2]+ '" target="_blank" title="'+os[1]+'" class="url" onclick="javascript:showContent()">'+ os[2]+ '</a>';
			}
			if (os[5] != '0' && os[5] != '1') {
				result += '<br><a href="'+ os[2]+ '" target="'+ os[5]+ '" title="'+os[1]+'" class="url" onclick="javascript:showContent()">'+ os[2]+ '</a>';
			}
		}
		result += '</li>\n';
	}
	result += '</ul>';
	result += '<hr/>';
	if (getmobileindex) {
		result += '<br/><p onclick="searchFullIndex()" class="resultcount" style="cursor:pointer">'+lf3+'</p>';
	}
	//Display the requested content
	var hlp = document.getElementById("resultcontainer")
	if (hlp) hlp.innerHTML = result	
}

// ============================================================================================================
// Switch to the full wh_data index upon request
// ============================================================================================================
var getmobileindex =mobile;

function searchFullIndex() {
	//get data.js and assign values to global array s[]
	getFullIndex();
	
}
function getFullIndexCallback(cbValue){
	if (cbValue) {
		s=cbValue;
		getmobileindex="";
	}
	doSearch(tip_Form);
}
function getFullIndex() {
	var s; //local array
	try {
		if (window.XMLHttpRequest) {// code for IE7+, Firefox, Chrome, Opera, Safari
			xhttp=new XMLHttpRequest();
		}
		else {// code for IE6, IE5
			xhttp=new ActiveXObject("Microsoft.XMLHTTP");
		}
		
		xhttp.onreadystatechange = function() {
			if (this.readyState == 4 && this.status == 200) {
				content = this.responseText;
		eval(content);
				xhttp=null;				
				getFullIndexCallback(s);
				
}
			else if(this.readyState == 4 && this.status != 200){
				xhttp=null;
			}
		};
		xhttp.open("GET","wh_data.js",true);
		xhttp.send();
	
	}
	catch(e) {
		console.log(e);		
		console.log("Full text search not loaded.");		
	}

	
}